/*  
PGSLMain.cpp - The main function for calling PGSL4 VB Interface

Copyright (C) Benny Raphael  

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or  any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


*/

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

#include "DummyWrapper.h"

using namespace PGSLVBCntrl;	// PGSL VB Interface is defined in this namespace
using namespace PGSLMain;		// PGSL C++ wrapper classes are defined in this namespace


int _tmain()
{
	int i;
	int numvars;

	PGSLVBWrapper *optimisationSetup;

	// Modify the following statement to instantiate the class in which your problem is defined
	// Note that the dll containing the .NET class should be added to the References section of the project
	optimisationSetup = new Sample();  
	//optimisationSetup = new F8();		// Uncomment this line if you want to optimise F8

	DummyWrapper *wrapper = new DummyWrapper();  //  This is a C++ class to wrap PGSL C code
	wrapper->runOptimisation(optimisationSetup);

	/*  Printing the results  */
    Console::WriteLine(S"PGSL completed");
	numvars = optimisationSetup->numVariables;
	for (i=0; i < numvars; i++) {
		printf("%d \t %lf\n", i, optimisationSetup->get_minimumPoint(i) );
	}
	printf("Minimum cost = %lf\n", optimisationSetup->globalMinimum );
	printf("%d trials\n",  optimisationSetup->numEvaluations );

	return 0;
}