'
' This class belongs to PGSL VB Version
' 
' Copyright (C) Benny Raphael  
' 
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or  any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
' 
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


' This is a sample class to denote how a PGSL problem is defined in the VB version
Public Class Sample
    Inherits PGSLVBWrapper

    Sub New()
        Dim xmin As Double = -5.12
        Dim xmax As Double = 5.11
        Dim xprecision As Double = 0.0001

        ' Perform any other initialisation of variables here

        MyBase.numVariables = 3
        MyBase.threshold = 0.0001
        MyBase.axes(0) = New Axis(xmin, xmax, xprecision)   ' Specifying the bounds and precision for the first variable
        MyBase.axes(1) = New Axis(xmin, xmax, xprecision)   ' Specifying the bounds and precision for the second variable
        MyBase.axes(2) = New Axis(xmin, xmax, xprecision)   ' Specifying the bounds and precision for the third variable
        MyBase.NS = 2
        MyBase.NPUC = 1
        MyBase.NFC = 60
        MyBase.NSDC = 20

    End Sub

    ' This is the objective function to be minimised
    ' the argument point contains the values of variables suggested by PGSL.  The user should 
    ' compute and return the evaluation of the point as a double
    Public Overrides Function objectiveFunction() As Double
        Dim x1 As Double = currentPoint(0)
        Dim x2 As Double = currentPoint(1)
        Dim x3 As Double = currentPoint(2)

        Dim value = (x1 - 1) * (x1 - 1) + (x2 - 2) * (x2 - 2) + (x3 - 3) * (x3 - 3)
        objectiveFunction = value

    End Function

    ' this function is called by PGSL after the completion of the optimisation
    ' Use this function to perform any saving of results 
    Public Overrides Function optimisationCompleted() As Integer

        'This is how the results are obtained
        Dim bestcost As Double = MyBase.globalMinimum
        Dim x1 As Double = MyBase.minimumPoint(0)
        Dim x2 As Double = MyBase.minimumPoint(1)
        Dim x3 As Double = MyBase.minimumPoint(2)
        Dim totalNumEvaluations = MyBase.numEvaluations

        ' Save results here

    End Function
End Class
